## Research and experimentation

Eager execution provides an imperative, define-by-run interface for advanced
operations. Write custom layers, forward passes, and training loops with auto
differentiation. Start with these notebooks, then read the
[eager execution guide](https://www.tensorflow.org/guide/eager).

1. [Eager execution basics](./eager_basics.ipynb)
2. [Automatic differentiation and gradient tapes](./automatic_differentiation.ipynb)
3. [Custom training: basics](./custom_training.ipynb)
4. [Custom layers](./custom_layers.ipynb)
